#include <cstdio>
#include <cstring>
#include <screen.hpp>

void Screen::resize(std::size_t n) {
    w = n; h = 1;
    buf = (char *)realloc(buf, n * sizeof(char));
}

void Screen::resize(std::size_t x, std::size_t y) {
    w = x; h = y;
    buf = (char *)realloc(buf, x * y * sizeof(char));
}

char &Screen::at(std::size_t n) { return buf[n]; }
char &Screen::at(std::size_t x, std::size_t y) {
    auto idx = (int)(((y-dy)/sy) * w) + (int)((x-dx)/sx);
    if(idx >= w *h) return _dummy;
    return buf[idx];
}

void Screen::clear() {
    memset(buf, ' ', w*h);
}

void Screen::draw() {
    gotoxy(0, 0);
    for(int i = 0; i < h; ++i) {
	for(int j = 0; j < w; ++j) {
	    std::fputc(at(j, i), stdout);
	}
	std::fputc('\n', stdout);
    }
}
